<html>
<head>
<title>Ogre::ScriptLoader Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1ScriptLoader.html">ScriptLoader</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::ScriptLoader Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::ScriptLoader" -->
<p>Abstract class defining the interface used by classes which wish to perform script loading to define instances of whatever they manage.  
 <a href="classOgre_1_1ScriptLoader.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreScriptLoader_8h_source.html">OgreScriptLoader.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::ScriptLoader:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1ScriptLoader__inherit__graph.gif" border="0" usemap="#Ogre_1_1ScriptLoader_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1ScriptLoader_inherit__map" id="Ogre_1_1ScriptLoader_inherit__map">
<area shape="rect" id="node3" href="classOgre_1_1OverlayManager.html" title="Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them..." alt="" coords="207,85,359,115"/><area shape="rect" id="node5" href="classOgre_1_1ParticleSystemManager.html" title="Manages particle systems, particle system scripts (templates) and the available emitter &amp; affector fa..." alt="" coords="184,139,381,168"/><area shape="rect" id="node7" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler." alt="" coords="201,192,364,221"/><area shape="rect" id="node45" href="classOgre_1_1ScriptCompilerManager.html" title="Manages threaded compilation of scripts." alt="" coords="185,245,380,275"/><area shape="rect" id="node9" href="classOgre_1_1CompositorManager.html" title="Class for managing Compositor settings for Ogre." alt="" coords="463,5,636,35"/><area shape="rect" id="node11" href="classOgre_1_1FontManager.html" title="Manages Font resources, parsing .fontdef files and generally organising them." alt="" coords="483,59,616,88"/><area shape="rect" id="node13" href="classOgre_1_1GpuProgramManager.html" title="Ogre::GpuProgramManager" alt="" coords="459,112,640,141"/><area shape="rect" id="node25" href="classOgre_1_1HighLevelGpuProgramManager.html" title="This ResourceManager manages high&#45;level vertex and fragment programs." alt="" coords="431,165,668,195"/><area shape="rect" id="node27" href="classOgre_1_1MaterialManager.html" title="Class for managing Material settings for Ogre." alt="" coords="472,219,627,248"/><area shape="rect" id="node29" href="classOgre_1_1MeshManager.html" title="Handles the management of mesh resources." alt="" coords="480,272,619,301"/><area shape="rect" id="node31" href="classOgre_1_1SkeletonManager.html" title="Handles the management of skeleton resources." alt="" coords="471,325,628,355"/><area shape="rect" id="node33" href="classOgre_1_1TextureManager.html" title="Class for loading &amp; managing textures." alt="" coords="473,379,625,408"/><area shape="rect" id="node15" href="classOgre_1_1D3D11GpuProgramManager.html" title="Ogre::D3D11GpuProgramManager" alt="" coords="719,5,940,35"/><area shape="rect" id="node17" href="classOgre_1_1D3D9GpuProgramManager.html" title="Ogre::D3D9GpuProgramManager" alt="" coords="723,59,936,88"/><area shape="rect" id="node19" href="classOgre_1_1GLES2GpuProgramManager.html" title="Ogre::GLES2GpuProgramManager" alt="" coords="719,112,940,141"/><area shape="rect" id="node21" href="classOgre_1_1GLESGpuProgramManager.html" title="Ogre::GLESGpuProgramManager" alt="" coords="721,165,937,195"/><area shape="rect" id="node23" href="classOgre_1_1GLGpuProgramManager.html" title="Ogre::GLGpuProgramManager" alt="" coords="731,219,928,248"/><area shape="rect" id="node35" href="classOgre_1_1D3D11TextureManager.html" title="Ogre::D3D11TextureManager" alt="" coords="733,272,925,301"/><area shape="rect" id="node37" href="classOgre_1_1D3D9TextureManager.html" title="Ogre::D3D9TextureManager" alt="" coords="736,325,923,355"/><area shape="rect" id="node39" href="classOgre_1_1GLES2TextureManager.html" title="GL ES&#45;specific implementation of a TextureManager." alt="" coords="732,379,927,408"/><area shape="rect" id="node41" href="classOgre_1_1GLESTextureManager.html" title="GL ES&#45;specific implementation of a TextureManager." alt="" coords="736,432,923,461"/><area shape="rect" id="node43" href="classOgre_1_1GLTextureManager.html" title="GL&#45;specific implementation of a TextureManager." alt="" coords="745,485,913,515"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1ScriptLoader-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptLoader.html#ad7758f66fa9246639426f3044478f709">~ScriptLoader</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptLoader.html#a78189fd757a233f34d5d272f76f6abf6">getScriptPatterns</a> (void) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the file patterns which should be used to find scripts for this class.  <a href="#a78189fd757a233f34d5d272f76f6abf6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptLoader.html#a6bd73a15503c5cb29ed8b7e264e12293">parseScript</a> (<a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;stream, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;groupName)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Parse a script file.  <a href="#a6bd73a15503c5cb29ed8b7e264e12293"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ScriptLoader.html#a12af311e1399d48c02c57bb545b50497">getLoadingOrder</a> (void) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the relative loading order of scripts of this type.  <a href="#a12af311e1399d48c02c57bb545b50497"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Abstract class defining the interface used by classes which wish to perform script loading to define instances of whatever they manage. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Typically classes of this type wish to either parse individual script files on demand, or be called with a group of files matching a certain pattern at the appropriate time. Normally this will coincide with resource loading, although the script use does not necessarily have to be a <a class="el" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a> (which subclasses from this class), it may be simply a script loader which manages non-resources but needs to be synchronised at the same loading points. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Subclasses should add themselves to the <a class="el" href="classOgre_1_1ResourceGroupManager.html" title="This singleton class manages the list of resource groups, and notifying the various resource managers...">ResourceGroupManager</a> as a script loader if they wish to be called at the point a resource group is loaded, at which point the parseScript method will be called with each file which matches a the pattern returned from getScriptPatterns. </dd></dl>

<p>Definition at line <a class="el" href="OgreScriptLoader_8h_source.html#l00058">58</a> of file <a class="el" href="OgreScriptLoader_8h_source.html">OgreScriptLoader.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad7758f66fa9246639426f3044478f709"></a><!-- doxytag: member="Ogre::ScriptLoader::~ScriptLoader" ref="ad7758f66fa9246639426f3044478f709" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1ScriptLoader.html#ad7758f66fa9246639426f3044478f709">Ogre::ScriptLoader::~ScriptLoader</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a12af311e1399d48c02c57bb545b50497"></a><!-- doxytag: member="Ogre::ScriptLoader::getLoadingOrder" ref="a12af311e1399d48c02c57bb545b50497" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1ScriptLoader.html#a12af311e1399d48c02c57bb545b50497">Ogre::ScriptLoader::getLoadingOrder</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the relative loading order of scripts of this type. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A value representing the relative loading order of these scripts compared to other script users, where higher values load later. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1ScriptCompilerManager.html#afa8446b5cebc0af9731dcdfd9620634b">Ogre::ScriptCompilerManager</a>, <a class="el" href="classOgre_1_1ResourceManager.html#a917b69fbaf300dcb0488d14d357296df">Ogre::ResourceManager</a>, <a class="el" href="classOgre_1_1ParticleSystemManager.html#aacabac2c2f38df11a51972c215645752">Ogre::ParticleSystemManager</a>, and <a class="el" href="classOgre_1_1OverlayManager.html#a0fe98c5950e94bb2bbad458d751e817e">Ogre::OverlayManager</a>.</p>

</div>
</div>
<a class="anchor" id="a78189fd757a233f34d5d272f76f6abf6"></a><!-- doxytag: member="Ogre::ScriptLoader::getScriptPatterns" ref="a78189fd757a233f34d5d272f76f6abf6" args="(void) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; <a class="el" href="classOgre_1_1ScriptLoader.html#a78189fd757a233f34d5d272f76f6abf6">Ogre::ScriptLoader::getScriptPatterns</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the file patterns which should be used to find scripts for this class. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This method is called when a resource group is loaded if you use <a class="el" href="classOgre_1_1ResourceGroupManager.html#aafd69be90e1774f2a4b34c4e6dcaa38a" title="Internal method for registering a ScriptLoader.">ResourceGroupManager::_registerScriptLoader</a>. </dd></dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A list of file patterns, in the order they should be searched in. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1ScriptCompilerManager.html#a4d702e410c747e796f689639032ac2d5">Ogre::ScriptCompilerManager</a>, <a class="el" href="classOgre_1_1ResourceManager.html#a37ec0e845f49b7f7e3dc868456ced1e8">Ogre::ResourceManager</a>, <a class="el" href="classOgre_1_1ParticleSystemManager.html#abe3232bc03e3922103cff68713975b62">Ogre::ParticleSystemManager</a>, and <a class="el" href="classOgre_1_1OverlayManager.html#a737c0c7db5f2d0049420c494129196c9">Ogre::OverlayManager</a>.</p>

</div>
</div>
<a class="anchor" id="a6bd73a15503c5cb29ed8b7e264e12293"></a><!-- doxytag: member="Ogre::ScriptLoader::parseScript" ref="a6bd73a15503c5cb29ed8b7e264e12293" args="(DataStreamPtr &amp;stream, const String &amp;groupName)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1ScriptLoader.html#a6bd73a15503c5cb29ed8b7e264e12293">Ogre::ScriptLoader::parseScript</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">DataStreamPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>stream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>groupName</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Parse a script file. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">stream</td><td>Weak reference to a data stream which is the source of the script </td></tr>
    <tr><td class="paramname">groupName</td><td>The name of a resource group which should be used if any resources are created during the parse of this script. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classOgre_1_1ScriptCompilerManager.html#ab51871b7c9b5449f24bdd2ccb280b843">Ogre::ScriptCompilerManager</a>, <a class="el" href="classOgre_1_1ResourceManager.html#a8240f6bbf3449b1f2acdd476efbde821">Ogre::ResourceManager</a>, <a class="el" href="classOgre_1_1ParticleSystemManager.html#a6f16f9bc2b124c7d051bee9c0b0a5ff0">Ogre::ParticleSystemManager</a>, <a class="el" href="classOgre_1_1MaterialManager.html#a7e3d13469f80b5814e20f9f959384119">Ogre::MaterialManager</a>, <a class="el" href="classOgre_1_1OverlayManager.html#aceba4bfe36019ec756be252be387defc">Ogre::OverlayManager</a>, <a class="el" href="classOgre_1_1CompositorManager.html#a350a7cda7c7e63fa6d7243133b24c3f1">Ogre::CompositorManager</a>, and <a class="el" href="classOgre_1_1FontManager.html#ada6af0d588fd5c17f0f8f7904fa657a8">Ogre::FontManager</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreScriptLoader_8h_source.html">OgreScriptLoader.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:06
</p>
</body>
</html>
